/**
 * generated by Xtext 2.25.0
 */
package tdt4250.xjava;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Type Declaration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tdt4250.xjava.TypeDeclaration#getName <em>Name</em>}</li>
 *   <li>{@link tdt4250.xjava.TypeDeclaration#getSuperTypeRef <em>Super Type Ref</em>}</li>
 *   <li>{@link tdt4250.xjava.TypeDeclaration#getFieldDecls <em>Field Decls</em>}</li>
 *   <li>{@link tdt4250.xjava.TypeDeclaration#getMethodDecls <em>Method Decls</em>}</li>
 * </ul>
 *
 * @see tdt4250.xjava.XjavaPackage#getTypeDeclaration()
 * @model
 * @generated
 */
public interface TypeDeclaration extends EObject
{
  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see tdt4250.xjava.XjavaPackage#getTypeDeclaration_Name()
   * @model
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link tdt4250.xjava.TypeDeclaration#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>Super Type Ref</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Super Type Ref</em>' containment reference.
   * @see #setSuperTypeRef(TypeReference)
   * @see tdt4250.xjava.XjavaPackage#getTypeDeclaration_SuperTypeRef()
   * @model containment="true"
   * @generated
   */
  TypeReference getSuperTypeRef();

  /**
   * Sets the value of the '{@link tdt4250.xjava.TypeDeclaration#getSuperTypeRef <em>Super Type Ref</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Super Type Ref</em>' containment reference.
   * @see #getSuperTypeRef()
   * @generated
   */
  void setSuperTypeRef(TypeReference value);

  /**
   * Returns the value of the '<em><b>Field Decls</b></em>' containment reference list.
   * The list contents are of type {@link tdt4250.xjava.FieldDeclaration}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Field Decls</em>' containment reference list.
   * @see tdt4250.xjava.XjavaPackage#getTypeDeclaration_FieldDecls()
   * @model containment="true"
   * @generated
   */
  EList<FieldDeclaration> getFieldDecls();

  /**
   * Returns the value of the '<em><b>Method Decls</b></em>' containment reference list.
   * The list contents are of type {@link tdt4250.xjava.MethodDeclaration}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Method Decls</em>' containment reference list.
   * @see tdt4250.xjava.XjavaPackage#getTypeDeclaration_MethodDecls()
   * @model containment="true"
   * @generated
   */
  EList<MethodDeclaration> getMethodDecls();

} // TypeDeclaration
